#ifndef _ECDSA_H
#define _ECDSA_H

#include <gmp.h>
#include "ec.h"

extern void ecdsa_sign(
	EC *ec,						/* Elliptic curve paramaters */
	gmp_randstate_t state,		/* PRNG state, initialized by caller */
	mpz_t d,					/* Private key, 1 <= d < ec->n */
	mpz_t e,					/* Message to sign */
	mpz_t r,					/* Signature */
	mpz_t s);					/* Signature */

extern int ecdsa_verify(		/* Is the signature correct? */
	EC *ec,						/* Elliptic curve parameters */
	ECP *Q,						/* Public key (expanded) */
	mpz_t e,					/* Message */
	mpz_t r,					/* Signature */
	mpz_t s);					/* Signature */

#endif

